<?php
/*
 * the home page
 */
require_once("include_main.php");

InputPage::$method = "post";

ini_set("max_execution_time", "6000");  // this can take a while, assume max 100 minutes

// button to upload file to return licenses
$installFile="none";
class ButtonUploadApplication extends InputPageAction {
    
    public function ButtonUploadApplication($name, $label) {
        parent::__construct($name, $label);
        $this->autorender = false;
        $this->anyway = true;
    }
    
    function action(InputPage &$page, $phase) {
        global $installFile;
        $file = $page->getField("upload");
        if(!$file->valid()) {
            $page->render();
            return;
        }
        $dir = opendir(Config::installFileDir);
        if($dir === false) {
            if(mkdir(Config::installFileDir, 0755)) {
                $dir = opendir(Config::installFileDir);
            }
        }
        move_uploaded_file($file->status->path, Config::installFileDir.$file->status->name);
        if($dir !== false) {
            while ($file_tmp = readdir($dir)) {
                if(preg_match("/^.*\.tar\.gz$/", $file_tmp)) {
                    $installFile = $file_tmp;
                    break;
                }
            }
            closedir($dir);
        }
        if($installFile == "none") {
            if(file_exists(Config::installFileDir.$file->status->name)) {
                unlink(Config::installFileDir.$file->status->name);
            }
            $file->msg = tl::tl("No installation archive found.");
            $page->render();
            return;
        }
        rename (Config::installFileDir.$file->status->name, Config::installFile);
        $cmd="(/usr/bin/sudo /usr/local/bin/install_script.sh ".Config::applInstallLog.") >/dev/null &";
        system($cmd, $retval);
        // start installation script
        // if running
        $install = $page->getField("installrunning");
        if($retval != 0) {
            $install->value = false;
        } else {
            $file->autorender = false;
            $install->value = true;
            $page->pages[$page->pageNo]->checkInstall();
        }
        $page->render();
    }    
}

class ButtonUninstallApp extends MainInputPageOkCancelButton {
    public function ButtonUninstallApp($name, $pageNo, InputPage &$page) {
        parent::__construct($name, $pageNo, $page);
    }
    
    function action(InputPage &$page, $phase) {
        global $mainSession;

        $semaphore = new SemaphoreCommand;
        $app = $mainSession->getApp($page->applicationName);
        if($semaphore->getSemaphore() === false) {
            $errorMsg = tl::tl("The application is currently locked.");
            $page->warp(InputPage::relativeScriptName()."?_page=".InnovaphoneApplicationConsts::pageApplication."&".$page->getArgs()."&appldeleted=2"."&errormsg=".urlencode($errorMsg));
        } else {
            if($app->uninstallScript != "") {
                $ret = trim(main_system($app->uninstallScript, $resVal));
                if($ret !== "" || $resVal !== 0) {
                    $page->warp(InputPage::relativeScriptName()."?_page=".InnovaphoneApplicationConsts::pageApplication."&".$page->getArgs()."&appldeleted=2"."&errormsg=".urlencode($ret));
                    return; 
                }
                $page->warp(InputPage::relativeScriptName()."?_page=".InnovaphoneApplicationConsts::pageApplication."&".$page->getArgs()."&appldeleted=1");
            }
        }
    }
}

class PageApplication extends MyPage {
	public function getHelpAnchor() {
        switch($this->parent->currentTab) {
            case InnovaphoneApplicationConsts::tabList: 
                switch($this->parent->currentMode) {
                    case InnovaphoneApplicationConsts::modeAskUninstall:
                    case InnovaphoneApplicationConsts::modeAskUninstall: 
                        return "#Uninstall";
                    default : return "#List";
                }
            case InnovaphoneApplicationConsts::tabUpload: 
                switch($this->parent->currentMode) {
                    default : return "#Upload.2FUpdate";
                }
            default: return "";
        }
	}
	
	public function getDefaultTab() {
        return InnovaphoneApplicationConsts::tabList;
	}
	
	public function createFields() {
        $this->addSection(InnovaphoneApplicationConsts::tabList, 1);
        $this->addSection(InnovaphoneApplicationConsts::tabUpload, 1);
        
        $genericHint = "";
        
		$this->parent->addTabMenuItem(tl::tl("List"), "javascript:submitTab('".InnovaphoneApplicationConsts::tabList."')", $this->parent->currentTab == InnovaphoneApplicationConsts::tabList);
		$this->parent->addTabMenuItem(tl::tl("Upload/Update"), "javascript:submitTab('".InnovaphoneApplicationConsts::tabUpload."')", $this->parent->currentTab == InnovaphoneApplicationConsts::tabUpload);
		
        switch($this->parent->currentTab) {
            case InnovaphoneApplicationConsts::tabList: 
                $this->tabList();
                break;
            case InnovaphoneApplicationConsts::tabUpload: 
                $this->tabUpload();
                break;
        }
	}
   
    public function addActionText() {
        $text = $this->addField(new InputPageText("uninstallapp_{$this->currentSection}" , ""));
        $text->autorender = false;
        $text->fullline = true;
        $deleted = InputPage::formInput("appldeleted");
        if($deleted == 1) {
            $text->value = tl::tlx('{$arg[1]} has been successfully uninstalled.', $this->parent->applicationName);
        } elseif($deleted == 2) {
            $text->value = "<div style=\"color:red\">".tl::tlx('Uninstall failed: {$arg[1]}', (isset($_GET["errormsg"]) && $_GET["errormsg"] != "") ? $_GET["errormsg"] : tl::tl("Look at your uninstall log."))."</div>";
        }
        if($text->value != "") {
            $text->autorender = true;
            $text->value = "<i>{$text->value}</i><p>&nbsp;</p>";
        }
    }
 
    public function tabList() {
        $this->currentSection = InnovaphoneApplicationConsts::tabList;
        
        $error = InputPage::formInput("error");
        if(isset($error)) {
            $errorField = $this->addField(new InputPageText("error", ""));
            $errorField->value = "<b>".tl::tl("An unexpected error occurred:")."</b>";
            $errorField->value .= "<br><div style=\"color:red\">$error</div><br><br>";
            $errorField->fullline = true;
        }
        
        $this->addActionText();
        MainMethods::performChecks($this);
        $text = $this->addField(new InputPageText("text", tl::tl("Below you see a list of your installed applications.")));
        
        $install = InputPage::formInput("install");
        if(isset($install)) {
            $text->value = "<b>".tl::tl("Linux has been successfully installed!")."</b><br><br>".$text->value;
        }
        $text->value .= "<br><i>".tl::tl("You can install new applications on the upload tab.")."</i>";

        switch($this->parent->currentMode) {
            case InnovaphoneApplicationConsts::modeAskUninstall:
                $this->uninstallApp();
                break;
        }
        $this->addList();
    }

    public function addList() {
        // fields below the green field, here the filter list
        $this->addSection(InnovaphoneApplicationConsts::tabList."_bottom", 1, false);
        $this->currentSection = InnovaphoneApplicationConsts::tabList."_bottom";

        $list = $this->addField(new MainInputPageListField("listapplications"));
        $emptyText = tl::tl("No applications installed");
        $empty = $list->fieldOnEmptyTable = new InputPageText("listapplicationsemptytable",
            "<b>$emptyText</b>");
        $empty->style = $this->currentSection;
        $name = $list->addColumn( new InputPageText($list->name."name", null), tl::tl("Name"));
        $name->sortType = genericInputPageItem::sortAlphanumericCaseIndependent;
        $desc = $list->addColumn( new InputPageText($list->name."desc", null), tl::tl("Description"));
        $desc->sortType = genericInputPageItem::sortAlphanumericCaseIndependent;
        $version = $list->addColumn(new InputPageText($list->name."version", null), tl::tl("Version"));
        $version->sortType = genericInputPageItem::sortAlphanumericCaseIndependent;
        $uninst = $list->addColumn(new InputPageText($list->name."uninst", null), tl::tl("Uninstall"));
        $uninst->sortType = genericInputPageItem::sortAlphanumericCaseIndependent;
    }
    
    public function tabUpload() {
        global $installFile;
        $this->currentSection = InnovaphoneApplicationConsts::tabUpload;
        MainMethods::performChecks($this);
        $install = $this->addField(new InputPageHiddenIdField("installrunning", false));
        
        $text = $this->addField(new InputPageText("text", ""));
        $install->value = InputPage::formInput($install->name);
        if(file_exists(Config::installFile)) {
            $install->value = true;
        } else {
            $install->value = false;            
        }
        if(!$install->value) {
            $text->value = tl::tl("Select an update archive or innovaphone application archive and upload it. It will be automatically installed after the upload.");
            $upload = $this->addField(new InputPageFileUploadField("upload", tl::tl("File")));
            $upload->button = &$this->addField(new ButtonUploadApplication("buttonupload", tl::tl("Upload")));
            $upload->emptyOk = true;
        }
        else {
            $this->checkInstall();
        }
    }
    
    public function checkInstall() {
        $text = $this->parent->getField("text");
        $install = $this->parent->getField("installrunning");
        $log = "";
        $error = "";
        $complete = parse_log_file(Config::applInstallLog, $log, $error);
        if(!$complete) {
            if($error != "") {
                $text->value = tl::tl("An error occurred during the installation:").
                            "<br><br><div style=\"color:red\">$error</div>";
                $install->autorender = false;
            }
            else {
                $refresh = 2;
                $text->value = tl::tlx('Installation is running. The page will be refreshed every {$arg[1]} seconds...', $refresh);
                $this->parent->metas += array("refresh" => $refresh . "; URL=".InputPage::relativeScriptName().
                    "?_page=".InnovaphoneApplicationConsts::pageApplication.
                    "&tab=".InnovaphoneApplicationConsts::tabUpload.
                    "&installrunning=1");
            }
        }
        else {
            $text->value = "<b>".tl::tl("Installation successfully completed.")."</b>";
            $install->autorender = false;
        }
        $this->addSection($this->currentSection."_bottom", 1, false);
        $this->currentSection = $this->currentSection."_bottom";
        $logField = $this->addField(new InputPageText("log", ""));
        $logField->value = $log;
    }
   
    public function uninstallApp() {
        global $mainSession;
        $app = $mainSession->getApp($this->parent->applicationName);
        $hintName = "uninstallhint";
        $this->currentSection = InnovaphoneApplicationConsts::modeAskUninstall;
        $this->addSection(InnovaphoneApplicationConsts::modeAskUninstall, 1, true, tl::tlx('Do you really want to uninstall {$arg[1]}?', $app->displayName));
        $text = $this->addField(new InputPageText("uninstall_{$this->currentSection}" , ""));
        $text->value = tl::tl("If you want to keep application data or configuration files, please make a backup before."); 
        $del = $this->addField(new ButtonUninstallApp("uninstallapplication", InnovaphoneApplicationConsts::pageApplication, $this->parent));
        $del->fullline = true;
        $del->attributes["onClick"] = "javascript:display_restore_hint('{$hintName}');";
        $this->addSection("uninstallhint", 1, false);
        $this->currentSection = "uninstallhint";
        $hint = $this->addField(new InputPageText($hintName, tl::tl("The uninstall process is running. Please be patient...")."<br><br>"));
        $hint->attributes["style"] = "display:none";
        $hint->attributes["id"] = $hint->name;
    }
 
    public function fillLists() {
        switch($this->parent->currentTab) {
            case InnovaphoneApplicationConsts::tabList:
                $this->fillApplicationList();
                break;
        }
    }
   
    public function fillApplicationList() {
        global $mainSession;

        $list = $this->parent->getField("listapplications");
        $rows = 0;
        $list->value = array();
        foreach($mainSession->apps as $app) {
            if(($app->href != "") && file_exists(Config::applicationsDir."/".$app->dir."/".$app->href)) {
                $href = Config::applicationsDir."/".$app->dir."/".$app->href;
                $list->value[$rows][$list->name."name"] = "<a class=\"myinno-listlink\" target=\"_blank\" href=\"{$href}\">{$app->displayName}</a>";
            }
            else {
                $list->value[$rows][$list->name."name"] = $app->displayName;
            }
            $list->value[$rows][$list->name."desc"] = $app->desc;
            $list->value[$rows][$list->name."version"] = $app->versionStr;
            if($app->uninstallScript != "") {
                $list->value[$rows][$list->name."uninst"] = $this->getModeLinkOnly(InnovaphoneApplicationConsts::modeAskUninstall, tl::tl("Uninstall"), "", "javascript:submitApplication('{$app->name}', '".InnovaphoneApplicationConsts::modeAskUninstall."')");
            }
            else {
                $list->value[$rows][$list->name."uninst"] = "";
            }
            $rows++;
        }
    }
}

final class InnovaphoneApplication extends MainInputPage {
    var $applicationName = "";

// constructor
    public function InnovaphoneApplication() {
        global $mainSession;

        parent::MainInputPage(tl::tl("innovaphone Applications"), "innovaphoneapplication");
		$this->setFieldSectionAttributes("inline", new _InputPageFieldSectionAttributes(array(), 1));
		
        $this->addField(new InputPageHiddenIdField("application_name", $this->applicationName));
        $this->applicationName = InputPage::formInput("application_name");
        if(!isset($this->applicationName)) {
            $this->applicationName = "";
        }
        
		// add proper fields to pages
        $this->pages = array(InnovaphoneApplicationConsts::pageApplication => new PageApplication($this, false));
		
		// update page
		$this->setDefaultTabProperties();
		$this->pages[$this->pageNo]->createFields();
	}
    
    public function getArgs() {
        if($this->applicationName != "") {
            $name = "application_name=".urlencode($this->applicationName)."&";
        }
        return "{$name}tab={$this->currentTab}";
    }
}

// create page
$page = new InnovaphoneApplication;

if($page->pageNo == InnovaphoneApplicationConsts::pageApplication) {
	$page->updateFields();
    $page->pages[$page->pageNo]->fillLists();
}

$page->work();

?>
